{****************************************************************}
{* 4-bit-full-adder-subtractor unit for LogicGates4 application *}
{****************************************************************}

unit addsub4f;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, ExtCtrls, StdCtrls, Grids, common;

type
  {************}
  { TfAddSub4f }
  {************}
  TfAddSub4f = class(TForm)
    Shape1: TShape;
    Shape2: TShape;
    StaticText1: TStaticText;
    Label2, Label8, Label9, Label10, Label18, laOperation: TLabel;
    laA1, laA2, laA4, laA8, laB1, laB2, laB4, laB8: TLabel;
    laS1, laS2, laS4, laS8, laM: TLabel;
    Shape20, Shape21, Shape22, Shape23, Shape25, Shape28, Shape29, Shape32, Shape35, Shape36: TShape;
    Shape37, Shape38, Shape39, Shape45, Shape50, Shape51, Shape52, Shape53, Shape54, Shape55: TShape;
    Shape56, Shape57, Shape58, Shape59, Shape60, Shape61, Shape62, Shape63, Shape64, Shape65: TShape;
    Shape66, Shape67, Shape68, Shape69, Shape70, Shape71, Shape72, Shape73, Shape74, Shape75: TShape;
    Shape76, Shape77, Shape78, Shape79, Shape80, Shape81, Shape82, Shape83, Shape84, Shape85: TShape;
    Shape86, Shape87, Shape88, Shape89, Shape90, Shape91, Shape92, Shape93, Shape94, Shape95: TShape;
    Shape96, Shape97, Shape98, Shape99, Shape100, Shape101, Shape102, Shape103, Shape104, Shape105: TShape;
    Shape106, Shape107, Shape108, Shape109, Shape110, Shape111, Shape112, Shape113, Shape114: TShape;
    Shape115, Shape116, Shape117, Shape118, Shape119, Shape120, Shape121, Shape122, Shape123: TShape;
    Shape124, Shape125, Shape126, Shape127, Shape128, Shape129, Shape130, Shape131, Shape132: TShape;
    Shape133, Shape134, Shape135, Shape136, Shape137, Shape138, Shape139, Shape140, Shape141: TShape;
    Shape142, Shape143, Shape144, Shape145, Shape146, Shape147, Shape148, Shape149, Shape150, Shape151, Shape152: TShape;
    Image1, Image2, Image3, Image4, Image5, Image6, Image7, Image8, Image9: TImage;
    imSwitchA1, imSwitchA2, imSwitchA4, imSwitchA8: TImage;
    imSwitchB1, imSwitchB2, imSwitchB4, imSwitchB8, imSwitchM: TImage;
    shSwitchA1a, shSwitchA1b, shSwitchA2a, shSwitchA2b, shSwitchA4a, shSwitchA4b, shSwitchA8a, shSwitchA8b: TShape;
    shSwitchB1a, shSwitchB1b, shSwitchB2a, shSwitchB2b, shSwitchB4a, shSwitchB4b, shSwitchB8a, shSwitchB8b, shSwitchMa, shSwitchMb: TShape;
    shLedA1, shLedA2, shLedA4, shLedA8: TShape;
    shLedB1, shLedB2, shLedB4, shLedB8: TShape;
    shLedS1, shLedS2, shLedS4, shLedS8: TShape;
    shLedCout, shLedM: TShape;
    sgSub: TStringGrid;
    btClose: TButton;
    procedure FormCreate(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure imSwitchA1Click(Sender: TObject);
    procedure imSwitchA2Click(Sender: TObject);
    procedure imSwitchA4Click(Sender: TObject);
    procedure imSwitchA8Click(Sender: TObject);
    procedure imSwitchB1Click(Sender: TObject);
    procedure imSwitchB2Click(Sender: TObject);
    procedure imSwitchB4Click(Sender: TObject);
    procedure imSwitchB8Click(Sender: TObject);
    procedure imSwitchMClick(Sender: TObject);
    procedure btCloseClick(Sender: TObject);
  private
    aLeds: TLeds;
    aSwitches: TSwitches;
    bSwitches, bLeds: TStatus;
  end;
const
  // Switches description: Data = objects positions (transparent image, long bar shape, short bar shape), horiz. closing move, vert. closing move
  DSwitches: array[0..8] of TSwitchData = (
    (Name: 'SwitchA1';
     Data: (512, 534, 514, 0, 1)),
    (Name: 'SwitchA2';
     Data: (378, 400, 380, 0, 1)),
    (Name: 'SwitchA4';
     Data: (246, 268, 248, 0, 1)),
    (Name: 'SwitchA8';
     Data: (112, 134, 114, 0, 1)),
    (Name: 'SwitchB1';
     Data: (577, 599, 579, 0, 1)),
    (Name: 'SwitchB2';
     Data: (444, 466, 446, 0, 1)),
    (Name: 'SwitchB4';
     Data: (310, 333, 313, 0, 1)),
    (Name: 'SwitchB8';
     Data: (177, 200, 180, 0, 1)),
    (Name: 'SwitchM';
     Data: (641, 663, 643, 0, 1))
  );

var
  fAddSub4f: TfAddSub4f;

implementation

{$R *.lfm}

{ 4-bit-full-adder-subtractor: Set switch position; do binary addition resp. subtraction; turn LEDs on/off; fill-in stringgrid }

procedure SwitchAndAddSub(DSwitches: array of TSwitchData; Switches: TSwitches; var SwitchStatus: TStatus; Leds: TLeds; var LedStatus: TStatus; IX: Integer);

var
  Exp, I: Integer;
  A, B, C, Sout, Cout, S1, S2, C1, C2: Boolean;
  Dec: array[0..3] of Integer;
  Bin, Compl: TBinary;

begin
  // Change current input from 0 to Vs (and vice-versa)
  SwitchStatus[IX] := not SwitchStatus[IX];
  // Corresponding LED status
  if IX = 8 then
    // Switch 8 = control signal (LED 13)
    LedStatus[13] := SwitchStatus[8]
  else
    // Switches 0 - 7 = input bits of A and B (LEDs 0 - 7)
    LedStatus[IX] := SwitchStatus[IX];
  // Set switch positions
  SwitchesOnOff(DSwitches, Switches, SwitchStatus);
  // Adapt grid label
  if SwitchStatus[8] then
    fAddSub4f.laOperation.Caption := '4 bits binary SUBTRACTION:'
  else
    fAddSub4f.laOperation.Caption := '4 bits binary ADDITION:';
  // Do the addition, using 4 1-bit-full-adders:
  // Addition of A and B (for M = 0); addition of A and the 2's complement of B (for M = 1)
  // The code logic is identical to what happens in the electronics circuit:
  // Cin of the first adder depends on M (this allows to add the bit needed for 2's complement)
  // The B inputs are inverted or not, depending on the result of the corr. XOR
  Cout := LedStatus[13];                                                       // Cin of first adder set to 0 or 1 (depending on control M)
  for I := 0 to 3 do begin
    A := LedStatus[I];                                                         // actual bit for A input
    B := LedStatus[13] xor LedStatus[I + 4];                                   // actual bit for B input, inverted or not (depending on control M)
    C := Cout;                                                                 // Cin = previous Cout
    // 1-bit-full-adder binary addition
    Adder(A, B, C, S1, C1, S2, C2, Sout, Cout);
    // Actual bit sum LED status
    LedStatus[I + 8] := SOut;
  end;
  // Cout of the last adder is carry value of 4-bit-addition, resp. indicates polarity of 4-bit-subtraction result
  LedStatus[12] := Cout;
  // Turn all LEDs on/off
  LedsOnOff(Leds, LedStatus);
  // Fill binary values into stringgrid
  for I := 0 to 3 do begin
    fAddSub4f.sgSub.Cells[5 - I, 1] := ' ' + IntToStr(Bits[LedStatus[I]]);
    fAddSub4f.sgSub.Cells[5 - I, 2] := ' ' + IntToStr(Bits[LedStatus[I + 4]]);
    fAddSub4f.sgSub.Cells[5 - I, 3] := ' ' + IntToStr(Bits[LedStatus[I + 8]]);
    Bin[3 - I] := LedStatus[I + 8];
  end;
  // For addition, fill in carry (if is 1)
  fAddSub4f.sgSub.Cells[1, 3] := '';
  if not LedStatus[13] then begin
    // Addition
    if LedStatus[12] then
      // There actually is a carry
      fAddSub4f.sgSub.Cells[1, 3] := ' ' + IntToStr(Bits[LedStatus[12]]);
  end;
  // Calculate and fill in result's 2nd complement
  Compl := Complement2(Bin);
  for I := 0 to 3 do begin
    fAddSub4f.sgSub.Cells[I + 2, 4] := '';
    // Display 2's complement only for subtraction
    if LedStatus[13] then
      fAddSub4f.sgSub.Cells[I + 2, 4] := ' ' + IntToStr(Bits[Compl[I]]);
  end;
  // Calculate decimal values
  Dec[0] := 0; Dec[1] := 0; Dec[2] := 0; Exp := 1;
  for I := 0 to 3 do begin
    Dec[0] += Bits[LedStatus[I]] * Exp; Dec[1] += Bits[LedStatus[I + 4]] * Exp; Dec[2] += Bits[LedStatus[I + 8]] * Exp;
    Exp *= 2;
  end;
  // Adjust decimal value of result
  if LedStatus[13] then begin
    // Subtraction: Decimal result may be positive or negative
    if Dec[0] < Dec[1] then
      Dec[2] := -(16 - Dec[2]);
  end
  else
    // Addition: Consideration of last adder's Cout to get correct decimal result
    Dec[2] += Bits[LedStatus[12]] * 16;
  // Fill-in decimal values
  for I := 0 to 2 do begin
    fAddSub4f.sgSub.Cells[6, I + 1] := ' ' + IntToStr(Dec[I]);
    if Abs(Dec[I]) < 10 then
      fAddSub4f.sgSub.Cells[6, I + 1] := ' ' + fAddSub4f.sgSub.Cells[6, I + 1];
    if Dec[I] >= 0 then
      fAddSub4f.sgSub.Cells[6, I + 1] := ' ' + fAddSub4f.sgSub.Cells[6, I + 1];
  end;
end;

{************}
{ TfAddSub4f }
{************}

{ Application start: Initialisation }

procedure TfAddSub4f.FormCreate(Sender: TObject);

begin
  // Arrays with switches (transparent image and bar shapes) and their "on/off" status
  SetLength(aSwitches, 9); SetLength(bSwitches, 9);
  aSwitches[0].Switch0 := imSwitchA1; aSwitches[0].Switch1 := shSwitchA1a; aSwitches[0].Switch2 := shSwitchA1b;
  aSwitches[1].Switch0 := imSwitchA2; aSwitches[1].Switch1 := shSwitchA2a; aSwitches[1].Switch2 := shSwitchA2b;
  aSwitches[2].Switch0 := imSwitchA4; aSwitches[2].Switch1 := shSwitchA4a; aSwitches[2].Switch2 := shSwitchA4b;
  aSwitches[3].Switch0 := imSwitchA8; aSwitches[3].Switch1 := shSwitchA8a; aSwitches[3].Switch2 := shSwitchA8b;
  aSwitches[4].Switch0 := imSwitchB1; aSwitches[4].Switch1 := shSwitchB1a; aSwitches[4].Switch2 := shSwitchB1b;
  aSwitches[5].Switch0 := imSwitchB2; aSwitches[5].Switch1 := shSwitchB2a; aSwitches[5].Switch2 := shSwitchB2b;
  aSwitches[6].Switch0 := imSwitchB4; aSwitches[6].Switch1 := shSwitchB4a; aSwitches[6].Switch2 := shSwitchB4b;
  aSwitches[7].Switch0 := imSwitchB8; aSwitches[7].Switch1 := shSwitchB8a; aSwitches[7].Switch2 := shSwitchB8b;
  aSwitches[8].Switch0 := imSwitchM;  aSwitches[8].Switch1 := shSwitchMa;  aSwitches[8].Switch2 := shSwitchMb;
  // Arrays with LEDs (shape) and their "on/off" status
  SetLength(aLeds, 14); SetLength(bLeds, 14);
  aLeds[0] := shLedA1; aLeds[1] := shLedA2; aLeds[2] := shLedA4; aLeds[3] := shLedA8;
  aLeds[4] := shLedB1; aLeds[5] := shLedB2; aLeds[6] := shLedB4; aLeds[7] := shLedB8;
  aLeds[8] := shLedS1; aLeds[9] := shLedS2; aLeds[10] := shLedS4; aLeds[11] := shLedS8;
  aLeds[12] := shLedCout; aLeds[13] := shLedM;
  // Use subscripts in input/output labels
  laA1.Caption := 'A' + SUB_Digits[0]; laA2.Caption := 'A' + SUB_Digits[1];
  laA4.Caption := 'A' + SUB_Digits[2]; laA8.Caption := 'A' + SUB_Digits[3];
  laB1.Caption := 'B' + SUB_Digits[0]; laB2.Caption := 'B' + SUB_Digits[1];
  laB4.Caption := 'B' + SUB_Digits[2]; laB8.Caption := 'B' + SUB_Digits[3];
  laS1.Caption := 'S' + SUB_Digits[0]; laS2.Caption := 'S' + SUB_Digits[1];
  laS4.Caption := 'S' + SUB_Digits[2]; laS8.Caption := 'S' + SUB_Digits[3];
end;

{ Form show-up: Initialize 4-bit-full-adder-subtractor simulation }

procedure TfAddSub4f.FormActivate(Sender: TObject);

var
  I: Integer;

begin
  // All switches (number inputs and control) to 0
  for I := 0 to Length(bSwitches) - 1 do
    bSwitches[I] := False;
  SwitchesOnOff(DSwitches, aSwitches, bSwitches);
  // All LEDs off
  for I := 0 to Length(bLeds) - 1 do
    bLeds[I] := False;
  LedsOnOff(aLeds, bLeds);
end;

{ Switch "A0, A1..." / "B0, B1..." activated: Update 4-bit-full-adder-subtractor simulation for actual switch positions }

procedure TfAddSub4f.imSwitchA1Click(Sender: TObject);

begin
  SwitchAndAddSub(DSwitches, aSwitches, bSwitches, aLeds, bLeds, 0);
end;

procedure TfAddSub4f.imSwitchA2Click(Sender: TObject);

begin
  SwitchAndAddSub(DSwitches, aSwitches, bSwitches, aLeds, bLeds, 1);
end;

procedure TfAddSub4f.imSwitchA4Click(Sender: TObject);

begin
  SwitchAndAddSub(DSwitches, aSwitches, bSwitches, aLeds, bLeds, 2);
end;

procedure TfAddSub4f.imSwitchA8Click(Sender: TObject);

begin
  SwitchAndAddSub(DSwitches, aSwitches, bSwitches, aLeds, bLeds, 3);
end;

procedure TfAddSub4f.imSwitchB1Click(Sender: TObject);

begin
  SwitchAndAddSub(DSwitches, aSwitches, bSwitches, aLeds, bLeds, 4);
end;

procedure TfAddSub4f.imSwitchB2Click(Sender: TObject);

begin
  SwitchAndAddSub(DSwitches, aSwitches, bSwitches, aLeds, bLeds, 5);
end;

procedure TfAddSub4f.imSwitchB4Click(Sender: TObject);

begin
  SwitchAndAddSub(DSwitches, aSwitches, bSwitches, aLeds, bLeds, 6);
end;

procedure TfAddSub4f.imSwitchB8Click(Sender: TObject);

begin
  SwitchAndAddSub(DSwitches, aSwitches, bSwitches, aLeds, bLeds, 7);
end;

{ Switch "M" activated: Update 4-bit-full-adder-subtractor simulation for actual switch positions }

procedure TfAddSub4f.imSwitchMClick(Sender: TObject);

begin
  SwitchAndAddSub(DSwitches, aSwitches, bSwitches, aLeds, bLeds, 8);
end;

{ Button "Close": Close the window }

procedure TfAddSub4f.btCloseClick(Sender: TObject);

begin
  Close;
end;

end.

